#ifndef Automaton_h
#define Automaton_h

/*the map is the objet who correlate the topology of the graph, and the creation of the
    neighborhood's(the vertex of the graphs)*/
#include "Map.h"
#include "Topology.h"
#include "Neighborhood.h"
#include "TowerNeighborhood.h"

#include <vector>
#include <iostream>

using namespace std;

template<class T>
class Automaton{
    
    //--------------------start of the inner variables--------------------------
    public:
      typedef struct  Node{
      /*The Node objects represents the node in the graph, contain a pointer to a state value in the 
      values matrix, and a pointers to other states in the matrix representing the vertex
      structure*/
      
      public:
          
      //the pointer to the game board
      T* centerCell;
      
       //the pointer to the game board clone
      //int* copyCenterCell;
      //the end index in the vector of Neighbor's pointer
      int endNeighbor;
      //the begin index in the vector of Neighbor's pointer
      int beginNeighbor;
      
      Node(T* cell, int begin, int end):centerCell(cell), beginNeighbor(begin), endNeighbor(end){}
      
    };
     
    //the pointer to the grid states
    T *pointerToNodes;
    T *copyPointerToNodes;
    
    //the cointainer of all the pointer's ("vertex") 
	//representing the neighbor's
    vector<T*> neighbors;
    
    //the graph container (node structure container)
    vector<Node> graph;
    
    /*this array's represents the dimensionality of the Automaton
	(the size of the array's dimension's)the number of the i 
	element in the array represent the number of "cell's" in the 
	i dimension*/
    static const int maxDimensions = 100;
    int dimSizes[maxDimensions];
    int copyDimSizes[maxDimensions];
	//-----------------------------------------------
    
	//////////////TO:DO//////////////////////////
	int dimension;
	////////////////////////////////////////////

	/*this int value is to "remember where starts, and finish"
	some neighborhood in the vertex's vector*/
    static int indexHood;
    
    /*the map is the objet who correlate the topology of the 
	graph, and the creation of the neighborhood's(the vertex of 
	the graphs)*/
    Map *map;
    
    Topology *topology;
    Neighborhood *neighborhood; 
    
    /*The states variable is for combinatory*/
    int states;
    //--------------end of the inner variables-----------------------------
        
    void createNode();
    
    void getNodePointer(vector<int> position);
    void getNodePointer(int position[]);
    void getNodePointer();
    /* If you want to access any element in the multi-dimensional
    array, the states array; use the pointer to the first element 
    and advance the pointer to the position array of the 
    element to acces */
            
    //public:
        Automaton(T *gridPointer, int Dsizes[], int dimesions):pointerToNodes(gridPointer), dimension(dimesions){
           for(int i=0;i < dimension; ++i){
               dimSizes[i] = Dsizes[i];              
           }
           topology = new Topology(dimension);
           for(int i=0;i<dimension;++i){
               topology->setDimensionSize(i, Dsizes[i]);
           }
           neighborhood = new TowerNeighborhood(); 
           map = new Map(topology, neighborhood);
        }
        void setMap();
        void getMap();
        void setNeighborhood();
        void getNeighborhood();
        void iterateOverTheSatesArray(int index=0);
    /*In this function are created all the neigbor's, and
    and set the pointers to the states matrix, the
    structure of the net is glue by union structures, they
    consist of one pointer to a cell (the center cell), and
    the index (index of a vector or array 
    container) of the pointer's  list, list of pointers to the 
    elements in the game board, the pointers represent 
    neighbor's of the center cells, the index represents
    the start, and end of a neighborhood of a the center 
    cell of the union*/
        void nextStep();
        
    
};

template<class T>
int Automaton<T>::indexHood = 0;

/*This method change the copy pointer(copyP) to a element in 
    the states array given by the position argument*/
template<class T>
void Automaton<T>::getNodePointer()
    {
    /* If you want to access any element in a multi-dimensional
    array, use a pointer to the first element and advance 
    the pointer to the position of the element that you want
    to change/access. 
	This method change the copy pointer(copyPointerToNodes) 
	global variable to point a element in the states array given by 
	the one dimenssional array, the position vector, the global 
	array copyDimSizes*/
    
        //first point the copy pointer to the [0][0][0]...[0]
        //position, the begining element of the array
        copyPointerToNodes = pointerToNodes; 
        /*whe need a int to count the positions 
		to move the pointer */
        int move = 0 ;
        
        //for all the elements in the given position
		//(the copyDimSizes position variable)
		//the copyDimSizes size is = dimension 
        for(int i=0; i<dimension; i++ ){
            //if is not the last element
            if( (i+1) < dimension){
                //multiply all the position index's for 
                //each dimension size    
                move = copyDimSizes[i];
                for(int j = (i+1); j < dimension; j++){        
                    move = (move)*(dimSizes[j]);
                }
                  copyPointerToNodes += move;
            }
            //if is the last element move the pointer the position
            //number     
            else
                copyPointerToNodes += copyDimSizes[i];
        } 
}//---------------getNodePointer()--------------------------

template<class T>
void Automaton<T>::getNodePointer(vector<int> position)
    {
    /* If you want to access any element in a multi-dimensional
    array, use a pointer to the first element and advance 
    the pointer to the position of the element that you want
    to change/access. 
	This method change the copy pointer(copyPointerToNodes) 
	global variable to point a element in the states array given by 
	the vector<int> position argument*/
    
        //first point the copy pointer to the [0][0][0]...[0]
        //position, the begining element of the array
        copyPointerToNodes = pointerToNodes;
        /*whe need a int to count the positions 
		to move the pointer */
        int move = 0 ;
        
        //for all the elements in the given position
		//(vector<int> position argument)
		//the position size is = dimension 
        for(int i=0; i<dimension; i++ ){
            //if is not the last element
            if( (i+1) < dimension ){
                //multiply all the position index's for 
                //each dimension size    
                move = position[i];
                for(int j = (i+1); j < dimension; j++){        
                    move = (move)*(dimSizes[j]);
                }
                //and move that number of times the pointer                                    
                copyPointerToNodes += move;
            }
            //if is the last element move the pointer the position
            //number     
            else
                copyPointerToNodes += position[i];
        } 
    }//---------------getNodePointer(vector<int> position)--------------------------

template<class T>
void Automaton<T>::getNodePointer(int position[])
    {
        //cout << "getNodePointer (int position[]), pointerToNodes "<<*pointerToNodes<<endl;
        /* If you want to access any element in a multi-dimensional
     array, pass a pointer to the first element and advance 
     the pointer to the position of the element that you want
     to change */
        
     /*this method change the copy pointer(copyP) to a element in 
    the states array given by the position argument*/
    
        //first point the copy pointer to the [0][0][0]...[0]
        //position, the begining element of the array
        copyPointerToNodes = pointerToNodes;
        //whe need a int to count the positions to move the
        //pointer 
        int move = 0 ;
        
        //for all the elements in the given positions
        for(int i=0; i<dimension; i++ ){
            //if is not the last element
            if( (i+1) < dimension ){
                //multiply all index of the position for the 
                //dimension of is respective dimension in the array     
                move = position[i];
                for(int j = (i+1); j < dimension; j++){        
                    move = (move)*(dimSizes[j]);
                }
                //and move that number of times the pointer                                    
                copyPointerToNodes += move;
            }
            //if is the last element move the pointer the position
            //number     
            else
                copyPointerToNodes += position[i];
        } 
    }//---------------getNodePointer(int position[])--------------------------
    
template<class T>
void Automaton<T>::createNode(){
    /*This method is for create the structure container of the
	couple node and vertex,the "structure" container is the graph,
	and consist of a center pointer to the states matrix,the node,
	and two index for the begining and end of the neighbor's
    vector container,the vertex's(links to the neighborhoods)*/
    
	/*This method use the copyDimSizes position array, this
	vector define the node coordinates in the grid, and the 
	setVertex(position) method from Map class is used to 
	find the vertex, map is the mixin betwem the topology class 
	and the neighborhood class.
	The generated vertex (pointers) are keep, in the
	neighbors vector container, and is size determine the
	index for the node*/
	
	//------------------------cambiar que no se creee cada vez
	//que llamas al metodo.
    vector<int> position;
    position.reserve(dimension);
    for(int i=0;i<dimension;++i){
        position.push_back(copyDimSizes[i]);
    }
	//--------------------------no se si esta bien esto------
	//calculate the neighborhood
    map->setVertex(position);
    vector< vector<int> > hood = map->getVertex();
	
	//keep the vertex pointer in the neighbors container
    for(int i=0;i<int(hood.size());++i){
        getNodePointer(hood[i]);
        neighbors.push_back(copyPointerToNodes);    
    }
	//and create the node
    Node cell(copyPointerToNodes, indexHood, (indexHood + int(hood.size())-1));
    //cout<< " center cell = " << *(cell.centerCell) << endl;
    
	//and laste change the index array for the next time
	indexHood = indexHood + int(hood.size());
    
	//keep the structure in the grahp vector container
    graph.push_back(cell);
    
}//------------createNode()-----------------

template<class T>
void Automaton<T>::iterateOverTheSatesArray(int index){    
    /*With this function you can iterate over an array independently
	of the dimension and element type of the array, this is done 
	tnx to the pointer to the first element of the array
	pointerToNodes, and the dimension sizes array dimSizes[maxDimensions];
    */   
	/*In this method you iterate over the states array to point
	all the elements independently of the dimension of the array
	and call the createNode() method, for each element in the array
	, the array is the "center cell", the "node" in the graph,
	but in the array there is no asociation betwen the elements,
	so in createNode() method, the pointer to the element is keep
	and the vertex structure of the node is set and keep to, in 
	the structure, for each element is create a Node structure, 
	and the structure are push in a vector container, the graph,
	now	the relationships betwen the vertexs and nodes are set,
	and the iteration over the array is done in the one
	dimencional	vector container, the graph, tnx to the 
	structures.
	*/
    
         //iterate over the first dimension 
        for( int i=0; i<dimSizes[index] ; ++i ){
            
			//now modify a copy of the dimension sizes array,
			//to use has the new position vector
			copyDimSizes[index] = i;                
                
                //if isn't the last dimension 
                if( (index + 1) < dimension){
                    /*use recursion to modify the copy of 
					the dimension sizes array, and start again
					but for the nexts dimensions
					*/
                    iterateOverTheSatesArray(index+1);                               
                }
                //if is the last dimension
                else{					
			/*modify a copy of the dimension sizes array,
			to use has the new position vector
            in the last dimension*/
					copyDimSizes[index] = i;
                    //and use the index (the new position vector)
                    //to create the Node ans vertex structure
                    createNode();
                }
        }       
}//----------iterateOverTheSatesArray-----------------

template<class T>
void Automaton<T>::nextStep(){
    
}//-----------nextStep()--------------------

#endif
