#ifndef Dimension_h
#define Dimension_h

class Dimension {
    /*This type of objects represent one dimension
    (an axe in the "picture"), and can be normalized, 
    like a ring, or with bounds*/

    //the size or numbers of coordinates in this axe
    int maxLimit;
    //is a ring (true) or a strand (with bounds)(false)
    bool normalized;
    
    public:
    
    //the constructor, creates a object, with a given 
    //size and type of bounds
    Dimension(int size=100, bool normalized=false): maxLimit(size), normalized(normalized){}
    
    // The copy-constructor:
    Dimension(const Dimension& d): maxLimit(d.maxLimit), normalized(d.normalized){}
    
    // the destructor
    ~Dimension(){}    
                
    //get set methods --------------------------
    int getSize(){return maxLimit;}
    void setSize(int dsize){maxLimit = dsize;}
    bool getNormalized(){return normalized;}  
    void setNormalized(){normalized = true;}
    //---------------------------------------
    
    /*this method is to know if a coordinate
    is outside of bounds*/ 
    bool isOutOfBounds(int coordinate);
    
    //this method is to return the position, in the dimension
    //only has sence to call it if the dim is normalized 
    int getPos(int coordinate); 
    
    //overrite the = operator to avoid problems when you
    //forget inizialize whit the contructor   
    Dimension& operator=(const Dimension& d) {
        maxLimit = d.maxLimit;
        normalized = d.normalized;
        return *this;
    }         
};
#endif
