#ifndef Neighborhood_h
#define Neighborhood_h

#include <vector>

using namespace std;

class Neighborhood{
    
    protected:
    //this is the container of neighbor's positions(vectors) 
    vector< vector<int> > neighborhood;
    
    //this vector will be used for create a neighbor position
    //and push in to the conatiner (the neighborhood) 
     vector<int> neighbor; 
    
    /*/represents how far we are gonna take neigbor's 
    //default value is one 
    //for example: if is a TowerNeighborhood of size one,
    //we have the four cardinal directions, every one
    //represesented for !one! neighbor 
    //so every cardinal direction is represented by a size
    //of neigbors*/
    int size;
    
    public:
     
    Neighborhood(int size = 1): size(size){}      
    //the destructor is virtual so if you want to clean
    //all resources created in the derived class, but
    //you only have a pointer to the base class (Polymorphism)
    //everithing works fine 
    virtual ~Neighborhood(){ }
    
    //------get methods-----------------------------
    
    vector< vector<int> > getNeighborhood(){return neighborhood;}
    
    int getSize(){return size;}        
    
    //------end get methods-------------------------         
    void setSize(int s){size = s;}
        
    
    //this is the main method in the class
    virtual void calculateNeighborhood(const vector<int> position) {};
                

};

#endif
