#ifndef Topology_h
#define Topology_h

#include "Dimension.h"
#include <vector>

using namespace std;

class Topology{
/*This class determines who is next to who, and the 
dimensions all in the grid "space" of course*/

    //represents the number of dimencion's objects
    int dimension;
    //represents the number of dimencion's objects
    //objects with no bound's
    int dimNormalized;
    
    //the dimension container
	vector<Dimension> dimensions; 
    
    public:
        
    //constructor
    Topology(int dim=1, int norm=0);
    
    // The copy-constructor:
    Topology(const Topology& t): dimension(t.dimension), dimNormalized(t.dimNormalized){}    
    
    //the destructor 
    //~Topology();
    
    //overrite the = operator to avoid problems when you
    //forget inizialize whit the contructor   
    Topology& operator=(const Topology& t) {
        dimension = t.dimension;
        dimNormalized = t.dimNormalized;
        return *this;
    }     
    //get methods---------------------------------  
    //return the dimension of the topology
    size_t getDimensionality(){return dimensions.size();}
    
    //return the number of "dimensions" with no bounds
    int getDimNormalized();
    
    //return the specific size of a dimension
    int getDimensionSize(int dim){
        return dimensions[dim].getSize();}
    
    //change the dimension size
    void setDimensionSize(int dim, int dsize){
        dimensions[dim].setSize(dsize);}  
                 
    //return if a specific dimension has no bounds
    bool getDimensionNormalized(int dim){
        return dimensions[dim].getNormalized();}
    
    //change the dimension normalization
    void setDimensionNormalized(int dim){
        dimensions[dim].setNormalized();}
    
    //return if a coordinate is out of bounds
	bool isOutOfBounds(vector<int> vect);
    
    //return the position (checking the bounds trip)
    vector<int> getPos(vector<int> vect);
    
    //get methods --------------------------------
};
#endif
